-- the only point of this plugin is to unload and then reload the MoorMap plugin so that the plugin can save it's current state (including CurrentMapID)
-- and then reload, effectively allowing it to bypass the ridiculous 15 second delay on loading settings, in this case map data.

import "GaranStuff.IRV.Class";
import "GaranStuff.IRV.VindarPatch";

import "Turbine";
import "Turbine.UI";

Loader=class(Turbine.UI.Window);
function Loader:Constructor()
	local tmpIndex;
	Turbine.UI.Window.Constructor(self);
	self:SetSize(0,0);
	self.Loaded=false;
	self.Update=function()
		if (Plugins["IRVReloader"] ~= nil) and (not self.Loaded) then
			self.Loaded=true;
			self:SetWantsUpdates(false);
			Turbine.PluginManager.UnloadScriptState("IRV");
			Turbine.PluginManager.LoadPlugin("IRV");
			Plugins["IRVReloader"].Unload=function()
				-- reset the "Reloading" flag
				PatchDataSave( Turbine.DataScope.Account, "IRV_Reloading", false );
			end
		end		
	end
	self:SetWantsUpdates(true);
end
loaderWindow=Loader();
